{
  "openapi": "3.1.0",
  "info": {
    "title": "Drive API",
    "version": "1.0.0",
    "description": "The Drive API provides comprehensive access to Plugsurfing's charging infrastructure network. It enables you to manage users, charging keys, search for charging locations, handle payments, and control charging sessions."
  },
  "servers": [
    {
      "url": "https://{environment}.plugsurfing.com",
      "variables": {
        "environment": {
          "enum": [
            "drive-api-stage"
          ],
          "default": "drive-api-stage",
          "description": "API environment - use drive-api-stage for testing and drive-api for production"
        }
      }
    }
  ],
  "tags": [
    {
      "name": "Geosearch",
      "description": "Search and retrieve detailed information about charging locations and stations"
    },
    {
      "name": "Users",
      "description": "Manage user accounts including creation, retrieval, updates, and deletion. Handles user-specific data and preferences."
    },
    {
      "name": "Charging Keys",
      "description": "Manage physical and virtual charging keys including creation, activation, updates, and status management. Essential for user access to charging stations."
    },
    {
      "name": "Sessions",
      "description": "Access and manage charging session data including history, status, and detailed session information"
    },
    {
      "name": "Remote Charging",
      "description": "Control charging sessions remotely including starting and stopping sessions, and monitoring session status"
    },
    {
      "name": "Payment Options",
      "description": "Manage payment methods and handle transaction processing for charging services"
    },
    {
      "name": "User Groups",
      "description": "Manage user group memberships"
    },
    {
      "name": "Vouchers",
      "description": "Redeem vouchers"
    },
    {
      "name": "Charging Key Orders",
      "description": "Handle the ordering and fulfillment process for physical charging keys"
    },
    {
      "name": "EMP Charging Keys",
      "description": "E-Mobility Provider specific endpoints for managing charging keys"
    },
    {
      "name": "EMP Geosearch",
      "description": "E-Mobility Provider specific endpoints for location search and information"
    },
    {
      "name": "EMP Orders",
      "description": "E-Mobility Provider specific endpoints for managing orders"
    },
    {
      "name": "EMP Sessions",
      "description": "E-Mobility Provider specific endpoints for managing charging sessions"
    },
    {
      "name": "EMP Fleets",
      "description": "E-Mobility Provider specific endpoints for managing fleets"
    }
  ],
  "paths": {
    "/drive/v1/users/{userId}/charging-keys/{referenceId}/activate": {
      "post": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Activate a charging key",
        "description": "Activates a charging key for a specific user. The key must exist and be unassigned. Once activated, the key can be used to start charging sessions.",
        "operationId": "activateUserChargingKey",
        "parameters": [
          {
            "name": "referenceId",
            "in": "path",
            "description": "Human-readable identifier written on the rfid card or tag, visualNumber from the charging key reservation.",
            "example": "DE*8PS*FR1RFK*4",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user who will own this charging key. Must be a valid user ID in your system.",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyActivateRequest"
              },
              "example": {
                "whitelist": "NEVER"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKey"
                },
                "example": {
                  "keyId": "0eb7732d-eb7a-418c",
                  "referenceId": "DE*8PS*AD21B1*3",
                  "contractId": "DE-8PS-C0AD21B13-Q",
                  "name": "My RFID key",
                  "validFrom": "2022-01-24T11:25:54.210Z",
                  "validTo": "2032-01-24T11:25:54.210Z",
                  "type": "card",
                  "enabled": true,
                  "whitelist": "NEVER",
                  "created": "2025-01-15T10:30:00Z",
                  "updated": "2025-01-15T10:30:00Z"
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User or charging key not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "409": {
            "description": "Key already in use",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/charging-keys/{identifier}": {
      "patch": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Edit a charging key",
        "description": "Modify a charging key's properties. You can change the key's name and enable/disable it. Disabling a key immediately prevents it from being used for charging. Important notes:\n- Only non-null fields in the request are applied\n- Disabling a key takes effect immediately across all charging stations\n- Some CPOs cache key status, so in rare cases it may take a few minutes for the disable action to propagate\n- Name changes are purely cosmetic and don't affect the key's functionality",
        "operationId": "updateUserChargingKey",
        "parameters": [
          {
            "name": "identifier",
            "in": "path",
            "description": "The unique identifier for the charging key - can be either the keyId (internal identifier) or contractId (roaming identifier)",
            "example": "0eb7732d-eb7a-418c",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user who owns the charging key",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyPatchRequest"
              },
              "example": {
                "name": "My RFID key updated",
                "enabled": true,
                "whitelist": "ALLOWED_OFFLINE"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKey"
                },
                "example": {
                  "keyId": "0eb7732d-eb7a-418c",
                  "referenceId": "DE*8PS*AD21B1*3",
                  "contractId": "DE-8PS-C0AD21B13-Q",
                  "name": "My RFID key",
                  "validFrom": "2022-01-24T11:25:54.210Z",
                  "validTo": "2032-01-24T11:25:54.210Z",
                  "type": "card",
                  "enabled": true,
                  "whitelist": "ALLOWED_OFFLINE",
                  "created": "2025-01-15T10:30:00Z",
                  "updated": "2025-01-15T10:30:00Z"
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User or charging key not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "409": {
            "description": "Conflict — can happen when making two requests to update the same charging key in a short period of time",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/charging-keys": {
      "get": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Get user's charging keys",
        "description": "Retrieves all charging keys associated with a specific user. This includes both active and inactive keys, physical and virtual keys. The response contains detailed information about each key including its status, type, and validity period.",
        "operationId": "listUserChargingKeys",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user whose charging keys should be retrieved",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "keys": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/ChargingKey"
                      }
                    }
                  }
                },
                "example": {
                  "keys": [
                    {
                      "keyId": "0eb7732d-eb7a-418c",
                      "referenceId": "DE*8PS*AD21B1*3",
                      "contractId": "DE-8PS-C0AD21B13-Q",
                      "name": "My RFID key",
                      "validFrom": "2022-01-24T11:25:54.210Z",
                      "validTo": "2032-01-24T11:25:54.210Z",
                      "type": "card",
                      "enabled": true,
                      "whitelist": "NEVER",
                      "created": "2025-01-15T10:30:00Z",
                      "updated": "2025-01-15T10:30:00Z"
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      },
      "post": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Create a charging key",
        "description": "Creates a new charging key for a specified user. Important notes:\n- The key will be created in an enabled state by default\n- Contract id, keyIdentifier and visualNumber must be provided.",
        "operationId": "createUserChargingKey",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user who will own the new charging key",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyPostRequest"
              },
              "example": {
                "name": "My RFID key",
                "keyIdentifier": "04A224B7C89280",
                "contractId": "DE-8PS-C0AD21B13-Q",
                "visualNumber": "DE*8PS*FR1RFK*4",
                "enabled": true,
                "whitelist": "NEVER"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKey"
                },
                "example": {
                  "keyId": "0eb7732d-eb7a-418c",
                  "referenceId": "DE*8PS*AD21B1*3",
                  "contractId": "DE-8PS-C0AD21B13-Q",
                  "name": "My RFID key",
                  "validFrom": "2022-01-24T11:25:54.210Z",
                  "validTo": "2032-01-24T11:25:54.210Z",
                  "type": "card",
                  "enabled": true,
                  "whitelist": "NEVER",
                  "created": "2025-01-15T10:30:00Z",
                  "updated": "2025-01-15T10:30:00Z"
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/charging-keys/plug-and-charge": {
      "post": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Create a Plug&Charge key",
        "description": "Creates a Plug&Charge charging key for a user. The key enables\nroaming authorization at PnC-capable charging stations.",
        "operationId": "createPncChargingKey",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user who will own the new Plug&Charge key",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Plug&Charge key creation request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyPlugAndChargePostRequest"
              },
              "example": {
                "pcid": "WDBRF61J21F123456",
                "contractId": "DE-8PS-C0AD21B13-Q"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "Plug&Charge key created successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKeyPlugAndChargePostResponse"
                },
                "example": {
                  "contractId": "DE-8PS-C0AD21B13-Q",
                  "pcid": "WDBRF61J21F123456",
                  "keyId": "DE-8PS-C0AD21B13-Q"
                }
              }
            }
          },
          "400": {
            "description": "Invalid request. Possible causes: PCID or contractId syntactically incorrect, contractId prefix not allowed for organization or Plug&Charge feature not enabled.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "fields": [
                    {
                      "name": "pcid",
                      "message": "PCID must be 17-18 alphanumeric characters",
                      "rejectedValue": "invalid"
                    }
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "409": {
            "description": "A charging key for this EMAID already exists (if EMAID-sharing is not allowed for the organization).",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "A charging key for this EMAID already exists"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Internal server error"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/charging-keys/orders": {
      "post": {
        "tags": [
          "Charging Key Orders"
        ],
        "summary": "Create charging key order",
        "description": "Orders a charging key for the given user. Requires the product to be configured on Plugsurfing side. Therefore, we ask you to reach out to us before using it.",
        "operationId": "createChargingKeyOrder",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyOrderRequest"
              },
              "example": {
                "productId": "physical-rfid-key",
                "quantity": 1,
                "address": {
                  "line1": "Kungsgatan 1",
                  "line2": "Floor 2",
                  "city": "Stockholm",
                  "postalCode": "11143",
                  "countryCode": "SE",
                  "firstName": "Olivier",
                  "lastName": "Payen",
                  "company": "Plugsurfing"
                }
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKeyOrderResponse"
                },
                "example": {
                  "id": "9aE20Rmj0v",
                  "state": "ORDER_PLACED",
                  "clientSecret": "pi_1J5J9v3sZvKYlo2C5J9v2eZv"
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "429": {
            "description": "Too many requests — a given user can't order more than 1 card every 5 minutes.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      },
      "get": {
        "tags": [
          "Charging Key Orders"
        ],
        "summary": "Get list of charging key orders",
        "description": "Returns the list of ordered charging keys by a given user.",
        "operationId": "listChargingKeyOrders",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKeyOrdersListResponse"
                },
                "example": [
                  {
                    "id": "vrj82A9EpJ",
                    "created": "2022-04-07T11:30:57.000Z",
                    "updated": "2022-04-07T11:30:57.000Z",
                    "address": {
                      "companyName": "Plusurfing",
                      "firstName": "Luck",
                      "lastName": "Thomson",
                      "addressLine1": "Rättarvägen 3",
                      "addressLine2": "Rättarvägen 3",
                      "postalCode": 12345,
                      "city": "Solna",
                      "country": "Sweden"
                    },
                    "quantity": 1,
                    "currency": "SEK",
                    "priceMinorInclVat": 1010,
                    "state": "ORDER_PLACED",
                    "hasReceipt": false
                  }
                ]
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/charging-keys/orders/{orderId}/receipt": {
      "get": {
        "tags": [
          "Charging Key Orders"
        ],
        "summary": "Get order receipt URL",
        "description": "Returns an absolute URL to the order's receipt. The receipt will be in PDF format.",
        "operationId": "getChargingKeyOrderReceiptUrl",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "orderId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKeyOrderReceiptResponse"
                },
                "example": {
                  "url": "string"
                }
              }
            }
          },
          "400": {
            "description": "Provided path parameter, is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "Receipt not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/charging-keys/orders/configuration": {
      "get": {
        "tags": [
          "Charging Key Orders"
        ],
        "summary": "Get pricing information per country",
        "description": "Returns the pricing information for ordering charging keys per country. Each country has to be set up manually for your organization in order for it to show up here.",
        "operationId": "getChargingKeyOrderConfiguration",
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChargingKeyConfigurationResponse"
                },
                "example": {
                  "countries": [
                    {
                      "country": "SE",
                      "currency": "SEK",
                      "priceMinorInclVat": 1,
                      "vat": 1
                    }
                  ]
                }
              }
            }
          },
          "404": {
            "description": "No pricing found for organization",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/charging-keys/reservations": {
      "post": {
        "tags": [
          "Charging Keys"
        ],
        "summary": "Reserve a charging key",
        "description": "Create connection between uid (physical chip id) and visualNumber (called later 'referenceId'), so that the latter can be used for activation.",
        "operationId": "createChargingKeyReservation",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ChargingKeyReservationsRequest"
              },
              "example": {
                "amount": 5,
                "countryCode": "DE",
                "products": [
                  "RFID_CARD"
                ],
                "userId": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
                "language": "en"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/geosearch/radius": {
      "post": {
        "summary": "Radius search",
        "description": "Find charging locations within a specified radius around a geographic point. The center point, distance, limit, and aggregation settings are passed via query parameters; the request body contains only filters. Use an empty JSON body (`{}`) when no filters are needed. Returns up to 300 locations sorted by proximity to the search center (nearest first). Prices are not included. To get prices for a given location, use Get location by id.",
        "operationId": "searchLocationsByRadius",
        "tags": [
          "Geosearch"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RadiusRequest"
              },
              "examples": {
                "remoteStartFilter": {
                  "summary": "Filter by remote start capability",
                  "value": {
                    "filters": {
                      "connectorStandards": [
                        "Type2"
                      ],
                      "capabilities": [
                        "REMOTE_START_STOP_CAPABLE"
                      ]
                    }
                  }
                },
                "plugAndChargeFilter": {
                  "summary": "Filter by Plug&Charge capability",
                  "value": {
                    "filters": {
                      "connectorStandards": [
                        "Combo"
                      ],
                      "capabilities": [
                        "PLUG_AND_CHARGE_CAPABLE"
                      ]
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "latitude",
            "in": "query",
            "required": true,
            "description": "Latitude of the center point in decimal degrees (e.g. N58°30' is represented as 58.5)",
            "example": 52.354551,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -90,
              "maximum": 90
            }
          },
          {
            "name": "longitude",
            "in": "query",
            "required": true,
            "description": "Longitude of the center point in decimal degrees (e.g. E014°45' is represented as 14.75)",
            "example": 4.7391593,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -180,
              "maximum": 180
            }
          },
          {
            "name": "distance",
            "in": "query",
            "description": "Search radius in meters",
            "schema": {
              "type": "integer",
              "default": 3000
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "Maximum number of individual locations to return. Not applicable when aggregation is enabled. Use a lower limit for faster response times.",
            "schema": {
              "type": "integer",
              "maximum": 300,
              "default": 300
            }
          },
          {
            "name": "aggregate",
            "in": "query",
            "description": "Enable result aggregation. Recommended for large search radii to improve response time.",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "aggregationPrecision",
            "in": "query",
            "description": "Controls the size of aggregation grid cells. Values range from 2 (largest cells) to 9 (smallest cells). Higher precision means smaller clusters but more data. If not specified, an appropriate value based on the search radius is used.",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 2,
              "maximum": 9
            }
          },
          {
            "name": "language",
            "schema": {
              "type": "string",
              "minLength": 2,
              "maxLength": 2
            },
            "in": "query",
            "required": false,
            "example": "en",
            "description": "Supported languages: en, bg, cy, de, es, fi, fr, hu, is, it, lt, nb, nl, pl, pt, ro, sv."
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BaseResponseListLocation"
                },
                "example": {
                  "locations": [
                    {
                      "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
                      "name": "Ebee Smart Technologies",
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "evses": [
                        {
                          "uid": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJG9qMC0Dp9OqeegGRXmiTOE",
                          "evse_id": "+49*839*030*000074",
                          "physical_reference": "4",
                          "status": "AVAILABLE",
                          "connectors": [
                            {}
                          ],
                          "capabilities": [
                            "RESERVABLE",
                            "PLUG_AND_CHARGE_CAPABLE",
                            "PLUG_AND_CHARGE_CAPABLE"
                          ],
                          "last_updated": "2025-01-15T10:30:00Z"
                        }
                      ],
                      "operator": {
                        "id": "881941",
                        "name": "Ebee Smart Technologies",
                        "hotline": "+498944255071",
                        "external_id": "DE*ABC"
                      },
                      "operator_display_name": "Sub-operator X",
                      "opening_times": {
                        "twentyfourseven": false,
                        "regular_hours": [
                          {
                            "weekday": 1,
                            "period_begin": "00:10",
                            "period_end": "29:59"
                          }
                        ],
                        "exceptional_openings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ],
                        "exceptional_closings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ]
                      },
                      "directions": [
                        {
                          "language": "DE",
                          "text": "example"
                        }
                      ],
                      "country": "DEU",
                      "state": "Bayern",
                      "city": "Berlin",
                      "postal_code": 10829,
                      "address": "EUREF CAMPUS 4-5",
                      "openNow": false,
                      "is_green_energy": false,
                      "last_updated": "2024-03-15T14:30:00Z"
                    }
                  ],
                  "aggregates": [
                    {
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "count": 1
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/geosearch/rectangle": {
      "post": {
        "summary": "Rectangle search",
        "description": "Find charging locations within a specified rectangle defined by two diagonal points. The rectangle coordinates are passed via the `topLatitude`, `bottomLatitude`, `leftLongitude`, and `rightLongitude` query parameters; the request body contains only filters. Returns up to 300 locations. Prices are not included. To get prices for a given location, use Get location by id",
        "operationId": "searchLocationsByRectangle",
        "tags": [
          "Geosearch"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RectangleRequest"
              },
              "examples": {
                "chargingProfileFilter": {
                  "summary": "Filter by charging profile capability",
                  "value": {
                    "filters": {
                      "connectorStandards": [
                        "Combo"
                      ],
                      "capabilities": [
                        "CHARGING_PROFILE_CAPABLE"
                      ]
                    }
                  }
                },
                "plugAndChargeFilter": {
                  "summary": "Filter by Plug&Charge capability",
                  "value": {
                    "filters": {
                      "connectorStandards": [
                        "Combo"
                      ],
                      "capabilities": [
                        "PLUG_AND_CHARGE_CAPABLE"
                      ]
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "topLatitude",
            "in": "query",
            "required": true,
            "description": "Latitude of the top edge of the rectangle in decimal degrees (e.g. N58°30' is represented as 58.5). Must be greater than bottomLatitude.",
            "example": 52.354551,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -90,
              "maximum": 90
            }
          },
          {
            "name": "bottomLatitude",
            "in": "query",
            "required": true,
            "description": "Latitude of the bottom edge of the rectangle in decimal degrees (e.g. S58°30' is represented as -58.5)",
            "example": 52.354551,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -90,
              "maximum": 90
            }
          },
          {
            "name": "leftLongitude",
            "in": "query",
            "required": true,
            "description": "Longitude of the left edge of the rectangle in decimal degrees (e.g. E014°45' is represented as 14.75). Must be less than rightLongitude.",
            "example": 4.7391593,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -180,
              "maximum": 180
            }
          },
          {
            "name": "rightLongitude",
            "in": "query",
            "required": true,
            "description": "Longitude of the right edge of the rectangle in decimal degrees (e.g. E014°45' is represented as 14.75)",
            "example": 4.7391593,
            "schema": {
              "type": "number",
              "format": "double",
              "minimum": -180,
              "maximum": 180
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "Maximum number of individual locations to return. Not applicable when aggregation is enabled. Use a lower limit for faster response times.",
            "required": false,
            "schema": {
              "type": "integer",
              "maximum": 300,
              "default": 300
            }
          },
          {
            "name": "aggregate",
            "in": "query",
            "description": "Enable result aggregation. Recommended for large search radii to improve response time.",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "aggregationPrecision",
            "in": "query",
            "description": "Controls the size of aggregation grid cells. Values range from 2 (largest cells) to 9 (smallest cells). Higher precision means smaller clusters but more data. If not specified, an appropriate value based on the search radius is used.",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 2,
              "maximum": 9
            }
          },
          {
            "name": "language",
            "schema": {
              "type": "string",
              "minLength": 2,
              "maxLength": 2
            },
            "in": "query",
            "required": false,
            "example": "en",
            "description": "Supported languages: en, bg, cy, de, es, fi, fr, hu, is, it, lt, nb, nl, pl, pt, ro, sv."
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BaseResponseListLocation"
                },
                "example": {
                  "locations": [
                    {
                      "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
                      "name": "Ebee Smart Technologies",
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "evses": [
                        {
                          "uid": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJG9qMC0Dp9OqeegGRXmiTOE",
                          "evse_id": "+49*839*030*000074",
                          "physical_reference": "4",
                          "status": "AVAILABLE",
                          "connectors": [
                            {}
                          ],
                          "capabilities": [
                            "RESERVABLE",
                            "PLUG_AND_CHARGE_CAPABLE",
                            "PLUG_AND_CHARGE_CAPABLE"
                          ],
                          "last_updated": "2025-01-15T10:30:00Z"
                        }
                      ],
                      "operator": {
                        "id": "881941",
                        "name": "Ebee Smart Technologies",
                        "hotline": "+498944255071",
                        "external_id": "DE*ABC"
                      },
                      "operator_display_name": "Sub-operator X",
                      "opening_times": {
                        "twentyfourseven": false,
                        "regular_hours": [
                          {
                            "weekday": 1,
                            "period_begin": "00:10",
                            "period_end": "29:59"
                          }
                        ],
                        "exceptional_openings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ],
                        "exceptional_closings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ]
                      },
                      "directions": [
                        {
                          "language": "DE",
                          "text": "example"
                        }
                      ],
                      "country": "DEU",
                      "state": "Bayern",
                      "city": "Berlin",
                      "postal_code": 10829,
                      "address": "EUREF CAMPUS 4-5",
                      "openNow": false,
                      "is_green_energy": false,
                      "last_updated": "2024-03-15T14:30:00Z"
                    }
                  ],
                  "aggregates": [
                    {
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "count": 1
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/geosearch/route": {
      "post": {
        "summary": "Route search",
        "description": "Search for charging locations along a route. The max number of points in a route is 300. Prices are not included. To get prices for a given location, use Get location by id",
        "operationId": "searchLocationsByRoute",
        "tags": [
          "Geosearch"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AlongRouteRequest"
              },
              "examples": {
                "routeSearch": {
                  "summary": "Search along a route",
                  "value": {
                    "points": [
                      {
                        "latitude": 52.52,
                        "longitude": 13.405
                      },
                      {
                        "latitude": 52.37,
                        "longitude": 4.9
                      }
                    ],
                    "filters": {
                      "connectorStandards": [
                        "Combo"
                      ]
                    }
                  }
                },
                "routeSearchWithPnC": {
                  "summary": "Search along a route for PnC-capable stations",
                  "value": {
                    "points": [
                      {
                        "latitude": 52.52,
                        "longitude": 13.405
                      },
                      {
                        "latitude": 52.37,
                        "longitude": 4.9
                      }
                    ],
                    "filters": {
                      "connectorStandards": [
                        "Combo"
                      ],
                      "capabilities": [
                        "PLUG_AND_CHARGE_CAPABLE"
                      ]
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "width",
            "in": "query",
            "description": "Distance to search from the center of the route, in meters (will be split equally on both sides of the route)",
            "schema": {
              "type": "number",
              "default": 3000
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "Number of locations returned in the response (doesn't apply when aggregation is enabled)",
            "schema": {
              "type": "number",
              "maximum": 300,
              "default": 300
            }
          },
          {
            "name": "aggregate",
            "in": "query",
            "description": "If true, the results will be aggregated. For large radius it makes the response much faster.",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "aggregationPrecision",
            "in": "query",
            "description": "Value between 2 and 9. The bigger value is, the smaller is the cell size of the grid for aggregation. If not passed, a default value, based on radius, is assumed.",
            "required": false,
            "schema": {
              "type": "number",
              "minimum": 2,
              "maximum": 9
            }
          },
          {
            "name": "language",
            "schema": {
              "type": "string",
              "minLength": 2,
              "maxLength": 2
            },
            "in": "query",
            "required": false,
            "example": "en",
            "description": "Supported languages: en, bg, cy, de, es, fi, fr, hu, is, it, lt, nb, nl, pl, pt, ro, sv."
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BaseResponseListLocation"
                },
                "example": {
                  "locations": [
                    {
                      "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
                      "name": "Ebee Smart Technologies",
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "evses": [
                        {
                          "uid": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJG9qMC0Dp9OqeegGRXmiTOE",
                          "evse_id": "+49*839*030*000074",
                          "physical_reference": "4",
                          "status": "AVAILABLE",
                          "connectors": [
                            {}
                          ],
                          "capabilities": [
                            "RESERVABLE",
                            "PLUG_AND_CHARGE_CAPABLE",
                            "PLUG_AND_CHARGE_CAPABLE"
                          ],
                          "last_updated": "2025-01-15T10:30:00Z"
                        }
                      ],
                      "operator": {
                        "id": "881941",
                        "name": "Ebee Smart Technologies",
                        "hotline": "+498944255071",
                        "external_id": "DE*ABC"
                      },
                      "operator_display_name": "Sub-operator X",
                      "opening_times": {
                        "twentyfourseven": false,
                        "regular_hours": [
                          {
                            "weekday": 1,
                            "period_begin": "00:10",
                            "period_end": "29:59"
                          }
                        ],
                        "exceptional_openings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ],
                        "exceptional_closings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ]
                      },
                      "directions": [
                        {
                          "language": "DE",
                          "text": "example"
                        }
                      ],
                      "country": "DEU",
                      "state": "Bayern",
                      "city": "Berlin",
                      "postal_code": 10829,
                      "address": "EUREF CAMPUS 4-5",
                      "openNow": false,
                      "is_green_energy": false,
                      "last_updated": "2024-03-15T14:30:00Z"
                    }
                  ],
                  "aggregates": [
                    {
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "count": 1
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/locations/{locationId}": {
      "get": {
        "tags": [
          "Geosearch"
        ],
        "summary": "Get location by id",
        "operationId": "getLocationById",
        "description": "Get location details, including prices. Only one of userId or keyIdentifier can be provided in a single request. If none are provided, default prices are returned. For more information on prices, check https://developer.plugsurfing.com/docs/geosearch#explanation",
        "parameters": [
          {
            "name": "locationId",
            "in": "path",
            "description": "Location id.",
            "example": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "userId",
            "in": "query",
            "description": "The id of a user, will be used to look up specific prices for this user",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "keyIdentifier",
            "in": "query",
            "description": "The keyIdentifier of a chargingKey, will be used to look up specific prices for this chargingKey",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "language",
            "schema": {
              "type": "string",
              "minLength": 2,
              "maxLength": 2
            },
            "in": "query",
            "required": false,
            "example": "en",
            "description": "Supported languages: en, bg, cy, de, es, fi, fr, hu, is, it, lt, nb, nl, pl, pt, ro, ru, sv."
          }
        ],
        "responses": {
          "200": {
            "description": "Location",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Location"
                },
                "example": {
                  "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
                  "name": "Ebee Smart Technologies",
                  "coordinates": {
                    "latitude": "52.475911",
                    "longitude": "13.350794"
                  },
                  "evses": [
                    {
                      "uid": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJG9qMC0Dp9OqeegGRXmiTOE",
                      "evse_id": "+49*839*030*000074",
                      "physical_reference": "4",
                      "status": "AVAILABLE",
                      "connectors": [
                        {
                          "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJEM0D69tJVN05/1hZ1zxqZSJ9kBdNsmfryS0+gvjLNZvdF1pDHJuCTydsJX6vPZh7U=",
                          "standard": "Type2",
                          "power": 22000,
                          "power_type": "AC_3_PHASE",
                          "price": {
                            "id": "4370769f30bd7927",
                            "description": "€ 0.56/kWh, € 0.10/min (> 2 h)",
                            "currency": "EUR",
                            "priceIncludesVat": "true",
                            "vatRate": "22",
                            "elements": [
                              {}
                            ]
                          },
                          "max_amperage": 32,
                          "max_voltage": 400
                        }
                      ],
                      "capabilities": [
                        "RESERVABLE",
                        "PLUG_AND_CHARGE_CAPABLE",
                        "PLUG_AND_CHARGE_CAPABLE"
                      ],
                      "last_updated": "2025-01-15T10:30:00Z"
                    }
                  ],
                  "operator": {
                    "id": "881941",
                    "name": "Ebee Smart Technologies",
                    "hotline": "+498944255071",
                    "external_id": "DE*ABC"
                  },
                  "operator_display_name": "Sub-operator X",
                  "opening_times": {
                    "twentyfourseven": false,
                    "regular_hours": [
                      {
                        "weekday": 1,
                        "period_begin": "00:10",
                        "period_end": "29:59"
                      }
                    ],
                    "exceptional_openings": [
                      {
                        "period_begin": "2025-01-15T10:30:00Z",
                        "period_end": "2025-01-15T10:30:00Z"
                      }
                    ],
                    "exceptional_closings": [
                      {
                        "period_begin": "2025-01-15T10:30:00Z",
                        "period_end": "2025-01-15T10:30:00Z"
                      }
                    ]
                  },
                  "directions": [
                    {
                      "language": "DE",
                      "text": "example"
                    }
                  ],
                  "country": "DEU",
                  "state": "Bayern",
                  "city": "Berlin",
                  "postal_code": 10829,
                  "address": "EUREF CAMPUS 4-5",
                  "openNow": false,
                  "is_green_energy": false,
                  "last_updated": "2024-03-15T14:30:00Z"
                }
              }
            }
          },
          "404": {
            "description": "Location not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/locations/{locationId}/live-data": {
      "get": {
        "tags": [
          "Geosearch"
        ],
        "summary": "Get location live data",
        "operationId": "getLocationLiveData",
        "description": "Returns live charging data for the EVSEs of a location that are in use, including since when each EVSE has had its current live status. The `charge_point_statuses` keys match the EVSE `uid` values returned by Get location by id. EVSEs without live data are omitted. Returns `404` when the location is not found or live data is not enabled for your organization. For details, check https://developer.plugsurfing.com/docs/geosearch#location-live-data",
        "parameters": [
          {
            "name": "locationId",
            "in": "path",
            "description": "Location id.",
            "example": "el00cee2f58f4cef4decacb32601ff563a97",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Live data of the location EVSEs",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/LocationLiveData"
                },
                "example": {
                  "charge_point_statuses": {
                    "ee006b89511e81534e019ca0d9a780b351e9": {
                      "status": "CHARGING",
                      "status_since": "2025-01-15T08:12:00Z"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Location not found or live data not enabled for your organization",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Internal server error"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/locations/batch": {
      "get": {
        "tags": [
          "Geosearch"
        ],
        "summary": "Batch locations",
        "operationId": "getLocationsBatch",
        "description": "Retrieve locations in batches. Locations are returned sorted by last_updated timestamp in ascending order.  Prices are not included, to get prices for a given location, use Get location by id. Best practices:\n1. Perform initial FULL PULL by paginating through all locations\n2. Perform regular DELTA PULLS using last_updated parameter to get only updated locations\n3. Use the last_updated value of the last location in the last page as the starting point for next DELTA PULL\n4. Perform periodic FULL PULLS to detect removed locations\n5. Use cursor to resume interrupted pulls",
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "description": "Optional - used to set page size value",
            "required": false,
            "schema": {
              "type": "number",
              "minimum": 10,
              "maximum": 500,
              "default": 50
            }
          },
          {
            "name": "cursor",
            "in": "query",
            "description": "Optional - pass cursor from previous response body to get next page.",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "last_updated",
            "in": "query",
            "description": "Optional - when set, only locations updated after this date are returned. example `2024-05-27T10:44:48Z`.",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "countries",
            "in": "query",
            "description": "Optional - when set, only locations in these countries are returned. example `DEU` or `DEU,FRA`.",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "power_type",
            "in": "query",
            "description": "Optional - when set, only locations having at least one connector with this power_type are returned. possible values: `AC` or `DC`.",
            "required": false,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchLocationsResponse"
                },
                "example": {
                  "locations": [
                    {
                      "id": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0gQhJv/Yjp5FXBJt14SccU9zFRdnC4SV7juPdCRaWkEZo=",
                      "name": "Ebee Smart Technologies",
                      "coordinates": {
                        "latitude": "52.475911",
                        "longitude": "13.350794"
                      },
                      "evses": [
                        {
                          "uid": "8rMCionje8s2LtheVGEK90mYnJdJe5OZd48ecF/w1StRJSodFFzfQ3GhJbYbxG0g3wFt7gLfnV3ulxmnoAzR4W/DFEMs63CndZpPK6L2aJG9qMC0Dp9OqeegGRXmiTOE",
                          "evse_id": "+49*839*030*000074",
                          "physical_reference": "4",
                          "status": "AVAILABLE",
                          "connectors": [
                            {}
                          ],
                          "capabilities": [
                            "RESERVABLE",
                            "PLUG_AND_CHARGE_CAPABLE",
                            "PLUG_AND_CHARGE_CAPABLE"
                          ],
                          "last_updated": "2025-01-15T10:30:00Z"
                        }
                      ],
                      "operator": {
                        "id": "881941",
                        "name": "Ebee Smart Technologies",
                        "hotline": "+498944255071",
                        "external_id": "DE*ABC"
                      },
                      "operator_display_name": "Sub-operator X",
                      "opening_times": {
                        "twentyfourseven": false,
                        "regular_hours": [
                          {
                            "weekday": 1,
                            "period_begin": "00:10",
                            "period_end": "29:59"
                          }
                        ],
                        "exceptional_openings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ],
                        "exceptional_closings": [
                          {
                            "period_begin": "2025-01-15T10:30:00Z",
                            "period_end": "2025-01-15T10:30:00Z"
                          }
                        ]
                      },
                      "directions": [
                        {
                          "language": "DE",
                          "text": "example"
                        }
                      ],
                      "country": "DEU",
                      "state": "Bayern",
                      "city": "Berlin",
                      "postal_code": 10829,
                      "address": "EUREF CAMPUS 4-5",
                      "openNow": false,
                      "is_green_energy": false,
                      "last_updated": "2024-03-15T14:30:00Z"
                    }
                  ],
                  "cursor": "string"
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/locations/operators": {
      "get": {
        "tags": [
          "Geosearch"
        ],
        "summary": "Get list of operators",
        "operationId": "listOperators",
        "description": "Returns the list of Charging Point Operators (CPOs) whose chargers are available through the geosearch endpoints. Can be used to let users filter on specific operators",
        "parameters": [
          {
            "name": "cursor",
            "in": "query",
            "description": "Cursor used to get next page. Returned from previous response from this endpoint. Should be URL encoded.",
            "example": "H6Zb4Z8p+4/vhPl9JKVHM+9/XWoF02I4EIKblAd3nMk=",
            "required": false,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/OperatorsListResponse"
                },
                "example": {
                  "operators": [
                    {
                      "id": 1547830,
                      "name": "string",
                      "externalId": "id_12345"
                    }
                  ],
                  "cursor": "H6Zb4Z8p+4/vhPl9JKVHM+9/XWoF02I4EIKblAd3nMk="
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/payment-options": {
      "get": {
        "tags": [
          "Payment Options"
        ],
        "summary": "Get user's payment methods",
        "description": "Retrieves all payment methods associated with a user.",
        "operationId": "listPaymentOptions",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user whose payment methods should be retrieved",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "oneOf": [
                      {
                        "$ref": "#/components/schemas/CreditCardPaymentOption"
                      }
                    ]
                  }
                },
                "example": [
                  {
                    "id": "STRIPE-7844364278189399",
                    "paymentMethod": "CREDIT_CARD",
                    "brand": "visa",
                    "displayBrand": "visa",
                    "countryCode": "DE",
                    "expMonth": 12,
                    "expYear": 2025,
                    "last4": "1234"
                  }
                ]
              }
            }
          },
          "400": {
            "description": "Bad Request - returned when payment method does not exist or it's already attached to any user",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      },
      "post": {
        "tags": [
          "Payment Options"
        ],
        "summary": "Add a new payment method",
        "description": "Adds a new payment method to a user's account. Important notes:\n- A user can only have one payment method at a time.",
        "operationId": "createPaymentOption",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user to add the payment method for",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "oneOf": [
                  {
                    "$ref": "#/components/schemas/CreateStripeCreditCardRequest"
                  }
                ]
              },
              "example": {
                "paymentMethodId": "pm_1N9KPP2eZvKYlo2CY8E0x92p"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "oneOf": [
                    {
                      "$ref": "#/components/schemas/CreditCardPaymentOption"
                    }
                  ]
                },
                "example": {
                  "id": "STRIPE-7844364278189399",
                  "paymentMethod": "CREDIT_CARD",
                  "brand": "visa",
                  "displayBrand": "visa",
                  "countryCode": "DE",
                  "expMonth": 12,
                  "expYear": 2025,
                  "last4": "1234"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request - returned when payment method does not exist or it's already attached to any user",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "409": {
            "description": "Conflict - returned if a payment option is already assigned to the user, and can be resolved by deleting the existing payment option first",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/payment-options/stripe-setup-intent": {
      "get": {
        "tags": [
          "Payment Options"
        ],
        "summary": "Get Stripe SetupIntent to confirm a payment method",
        "description": "Creates and returns a Stripe SetupIntent client secret so the user can securely attach a new payment method.",
        "operationId": "createStripeSetupIntent",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SetupIntent"
                },
                "example": {
                  "id": "seti_3N9KQw2eZvKYlo2C1Wm0R8AB",
                  "clientSecret": "seti_3N9KQw2eZvKYlo2C1Wm0R8AB_secret_example"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request - returned when payment method does not exist or it's already attached to any user",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/payment-options/{id}": {
      "delete": {
        "tags": [
          "Payment Options"
        ],
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "id",
            "in": "path",
            "description": "Payment option id",
            "example": "STRIPE-7844364278189399",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "summary": "Delete user's payment option",
        "description": "Removes a stored payment option from the specified user when the payment method is eligible for deletion.",
        "operationId": "deletePaymentOption",
        "responses": {
          "204": {
            "description": "Payment option was deleted successfully"
          },
          "400": {
            "description": "Bad Request - returned when payment method does not exist on this user.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "403": {
            "description": "Specified payment option cannot be deleted",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "404": {
            "description": "User or payment option not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/prepaid": {
      "get": {
        "tags": [
          "Payment Options"
        ],
        "summary": "Get user's prepaid balance",
        "description": "Retrieves the current prepaid balance for a specific user. Returns a breakdown of balances with their sources (e.g. Credit, Voucher) and expiry dates, as well as a total balance.",
        "operationId": "listPrepaid",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PrepaidBalance"
                },
                "example": {
                  "balanceTotal": {
                    "amountMinorUnits": 1000,
                    "currency": "EUR"
                  },
                  "balances": [
                    {
                      "expiryDate": "2024-12-31T23:59:59Z",
                      "amountMinorUnits": 1000,
                      "currency": "EUR",
                      "source": "Credit",
                      "initialAmountMinorUnits": 1000
                    }
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found or user has no prepaid balance",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
            "ApiKeyAuth": []
          }
        ]
      }
    },
    "/drive/v1/users/{userId}/sessions/history": {
      "post": {
        "tags": [
          "Sessions"
        ],
        "summary": "Get charging session history",
        "description": "Retrieves the charging session history for a specific user. The response includes detailed information about each session including:\n- Session status and duration\n- Energy consumption\n- Cost and payment details\n- Charging location information\n\nThe results can be filtered by:\n- Session status\n- Specific charging key\n- Date range\n\nPagination is supported through the cursor parameter.",
        "operationId": "listSessions",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The unique identifier of the user whose session history should be retrieved",
            "example": "6f36dc9b-446f-462b-aae0-95c7636d5c6c",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SessionsHistoryRequest"
              },
              "example": {
                "fromDate": "2025-01-01",
                "toDate": "2025-01-31",
                "limit": 20,
                "page": 1,
                "sortBy": "startTime",
                "sortDirection": "DESC"
              }
            }
          },
          "required": false
        },
        "responses": {
          "200": {
            "description": "Save the cursor to access next pages.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SessionsHistoryResponse"
                },
                "example": {
                  "sessions": [],
                  "total": 0,
                  "hasMore": false
                }
              }
            }
          },
          "400": {
            "description": "The provided query parameters, route parameters or body is invalid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InvalidRequestErrorResponse"
                },
                "example": {
                  "message": "Invalid request payload",
                  "details": [
                    "field X is required"
                  ]
                }
              }
            }
          },
          "404": {
            "description": "User not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "example": {
                  "message": "Resource not found"
                }
              }
            }
          }
        },
        "security": [
          {
[...]
